use serde::{Deserialize, Serialize};

#[derive(Deserialize, Debug)]
#[serde(tag = "t")]
pub enum ClientMessage<I, S> {
    #[serde(rename = "s")]
    SetState { s: S },
    #[serde(rename = "i")]
    Input { i: I },
    #[serde(rename = "g")]
    GetState { c: usize, s: S },
}

#[derive(Serialize, Debug)]
pub struct Meta {
    helo: Option<String>,
    version: &'static str,
}

#[derive(Serialize, Debug)]
#[serde(tag = "t")]
pub enum ServerMessage<I, S> {
    #[serde(rename = "m")]
    Meta { m: Meta },
    #[serde(rename = "s")]
    SetState { u: i8, s: S },
    #[serde(rename = "i")]
    Input { i: I },
    #[serde(rename = "g")]
    GetState { c: usize },
}
